import re
from typing import List
C=[]
F=[]
"""
with open("js-globals.md") as fi:
    x=fi.read()
y=re.findall("\* ```(\w+?)```(.*?)(?=\n\*)",x,re.DOTALL|re.MULTILINE)
y=[(i,j.replace("\n","\n\n")) for i,j in y]
#y=[(i,j) for i,j in y if re.match("DROID|DORDER",i)]
C.extend(y)"""

with open("js-objects.md") as fi:
    x=fi.read()
y=re.findall("```(\w+?)```(.*?)(?=`|\n+$)",x,re.DOTALL|re.MULTILINE)
y=[(i,j.replace("\n","\n\n")) for i,j in y]
#y=[(i,j) for i,j in y if re.match("DROID|DORDER",i)]
C.extend(y)



def sub2(y:List[str]):
    y=[(re.sub("<|>|\[|\]","",i),j) for i,j in y] 
    y=[(re.sub("\|","=",i),j) for i,j in y] 
    y=[(re.sub("(\w+?)\.\.\.",lambda i:"..."+i.group(1),i),j) for i,j in y] 
    return y

with open("js-functions.md") as fi:
    x=fi.read()
y=re.findall("## (.*?)\n\n(.*?)(?=#|\n+$)",x,re.DOTALL|re.MULTILINE)
y=sub2(y)
F.extend(y)

with open("js-events.md") as fi:
    x=fi.read()
y=re.findall("## (.*?)\n\n(.*?)(?=#|\n+$)",x,re.DOTALL|re.MULTILINE)
y=sub2(y)
F.extend(y)



C.sort()
F.sort()

d=[]
with open("pylint.js","w") as fi:
    with open("object0.js") as fi2:
        fi.write(fi2.read())
    for entry,doc in C:
        entry:str
        doc:str  
        if entry in d:
            continue
        d.append(entry)
        print(f"/**{doc.strip()}*/",file=fi)
        print(f"const {entry}='{entry}'",file=fi)
        print(f"",file=fi)    

    for entry,doc in F:
        entry:str
        doc:str
        fname=re.match("\w+",entry).group()
        print(fname)
        if fname in d:
            continue
        d.append(fname)
        ret=""
        if "Returns" in doc:
            if re.search("Returns.{0,10}(boolean|whether|true|false)",doc):
                ret="true"
            if re.search("Returns.{0,10}(num)",doc):
                ret="0"

        if fname.startswith("dist"):ret="0"
        if fname.startswith("pick"):ret="object0"
        if fname.startswith("componentAvailable"):ret="true"
        if fname.startswith("enum") or fname.startswith("find") or fname.startswith("get"):
            h="object"
            if fname.startswith("get"):h=""
            for w in ["Research","Droid","Struct","Object"]: 
                if w in fname:
                    h=w.lower()
                    break
            if fname=="enumCargo":
                h="droid"
            h=h+"0"

            if fname.startswith("enum") or fname.startswith("find") :
                h="[%s]"%h

            ret=h
        if ret:ret="return %s"%ret 
        print(f"/**{doc.strip()}*/",file=fi)
        print(f"function {entry} "+"{%s}"%ret,file=fi)
        print(f"",file=fi)

    with open("globals0.js") as fi2:
        fi.write(fi2.read())
